//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator 
// League of the RoboCup 2000 competition
//
// Copyright (C) 1998, 1999, 2000 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//-*- c++ -*-/////////////////////////////////////////////////////////// 
//
//   $Id: main.C,v 1.9 2000/10/19 15:58:19 goetz Exp $
//   $Manager: eri$
//
//   DemoAgent.C
//   cwz-build-command: make checklib samurai
////////////////////////////////////////////////////////////////////////

#include <stdlib.h>
#include <unistd.h>
#include <iostream.h>
#include <strings.h>
#include "constants.h"
#include "mastercontrol.h"

int main (int argc, char** argv) {
  char   *team_name= "MRB";
  char   *host= new char [strlen(DEFAULT_HOST)+1];
  strcpy (host, DEFAULT_HOST);
  int    port = PORT;
  double mapWinMag = 0.0;
  bool   logging = false;
  int    reconnectNumber = 0;
  bool   isGoalie= false;
  char   *configfile= "agent.conf";

  char   c;
  while((c = getopt( argc, argv, "gh:lm:r:p:t:f:" ) ) != EOF ) {
    switch(c) {
    case 'g':
      isGoalie = true;
      break;
    case 'h':
      delete (host);
      host = optarg;
      break;
    case 'l':
      logging = true;
      break;
    case 'm':
      mapWinMag = atof( optarg );
      break;
    case 'r':
      reconnectNumber = atoi(optarg);
      if ((reconnectNumber < 1) || (reconnectNumber > 11))
	goto arg_err;
      break;
    case 'p':
      port = atoi(optarg);
      break;
    case 't':
      team_name = optarg;
      break;
    case 'f':
      configfile= optarg;
      break;
    case '?':
    arg_err:		
    cerr << "Usage: " << argv[0] << "[-h HOSTNAME]"
      " [-l] [-m MAGNIFY] [-r num] [-p PORT] [-t TEAMNAME]" 
      "[-f FILENAME]" << endl
	 << "  -g           agent is goalie" << endl
	 << "  -h HOSTNAME  connects to HOSTNAME" << endl
	 << "  -l           enable server message logging (to \"snaps*.log\")" << endl
	 << "  -m MAGNIFY   enable mapwindow with size magnification factor MAGNIFY" << endl
	 << "  -r num       reconnect with that number" << endl
	 << "  -p PORT      port number" << endl
	 << "  -t TEAMNAME  sets the player's team name" << endl
	 << "  -f FILENAME  alternative configuration file for tactics (default agent.conf)" << endl;
    exit(1);
    }
  }

  cerr << "Mainz Rolling Brains RoboCup player" << endl
       << "copyright 1998, 1999, 2000 by the Mainz Rolling Brains team" 
       << endl;

  MasterControl *a = new MasterControl(team_name, isGoalie, host, port, 
				       mapWinMag, logging, reconnectNumber,
				       configfile);
  a->play();

  delete (a);
}


