//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator 
// League of the RoboCup 2000 competition
//
// Copyright (C) 1998, 1999, 2000 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

// -*- c++ -*- /////////////////////////////////////////////////
//
// $Id: mastercontrol.h,v 1.10 2000/10/19 15:27:37 goetz Exp $
//
// 
//
////////////////////////////////////////////////////////////////


#include <unistd.h>
#include "player.h"
#include "snapshot.h"


#include "standardsituationmodule.h"
#include "passmodule.h"
#include "passeval.h"
#include "ballhandlingmodule.h"
#include "goalkickmodule.h"
#include "goalkickeval.h"
#include "PositionModule.h"

class MasterControl : public Player {
public:
  MasterControl(const char* team, bool goalie, const char *host, int port, double mapwm, bool log, int recn, const char *configfile);
  ~MasterControl();

  virtual void act();
  
private:

  int lastTimeMsgSent;
  
  void sendAudioMsg(const Snapshot *);

  StandardSituationModule *standard;
  PassModule              *pass;
  PassEval                *passeval;
  BallHandlingModule      *ballhandling;
  GoalKickModule          *goalkick;
  GoalKickEval            *goaleval;
  TacticalModule          *tactical;
  PositionModule          *position;
};

