//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator 
// League of the RoboCup 2000 competition
//
// Copyright (C) 1998, 1999, 2000 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//
// OnlineCoach - simple online coach
//
// Time-stamp: <00/08/10 18:19:24 goetz>
//
//////////////////////////////////////////////////////////////////////

#include "mrbcoach.h"

#include <stdlib.h>
#include <unistd.h>
#include <iostream.h>

#include "constants.h"

int main (int argc, char *argv[])
{
  char *teamname= "MRB";
  char *host= "localhost" ;
  int port= OLCOACH_PORT;
  bool logging= false;
  double mapwin= -1.0;
  char c;
  while ((c= getopt( argc, argv, "t:h:p:lm:")) != EOF ) {
    switch (c) {
    case 't':
      teamname= optarg;
      break;
    case 'h':
      host= optarg;
      break;
    case 'p':
      port= atoi(optarg);
      break;
    case 'l':
      logging= true;
      break;
    case 'm':
      mapwin= atof(optarg);
      break;
    case '?':
    default:
    cerr << "Usage: " << argv[0] << "[-t TEAMNAME] [-h HOSTNAME]"
	 << "[-p PORTNO] [-l] [-m MAG]"
	 << endl
	 << " -l  enable logging" << endl
	 << " -m  mapwindow (with magnification MAG)" << endl
	 << endl;
      exit(1);
    }
  }

  cerr << "Mainz Rolling Brains RoboCup Online Coach" << endl
       << "copyright 1998, 1999, 2000 by the Mainz Rolling Brains team" 
       << endl;

  MrbCoach *mrbc= new MrbCoach(teamname, host, port, logging, mapwin);

  mrbc->coach();
  
  delete mrbc;

} // main()
