//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator 
// League of the RoboCup 2000 competition
//
// Copyright (C) 1998, 1999, 2000 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//-*- c++ -*-///////////////////////////////////////////////////////////
//
// mrbcoach.h - Online coach for MRB2000
//
// $Id: mrbcoach.h,v 1.4 2000/10/19 15:27:40 goetz Exp $
//
////////////////////////////////////////////////////////////////////////

#include "onlinecoach.h"
#include "coordinates.h"

class MrbCoach : public Onlinecoach
{
public:
  MrbCoach(const char *team, const char *host, const int port,
	   const bool logging= false, const double mapmag= -1.0);

  virtual void act(Snapshot *snap);
  virtual void analyze(Snapshot *snap);

private:
  bool sayMessageNow;
  play_mode lastMode;
  int countOfMsgsLeft;
  int thisGame;   // for counting 6000 cycle games ...
  
  // positions and numbers of goalies to determine whether a move was done
  int ourGoalieNo;
  int otherGoalieNo;
  Vector2d ourGoaliePos;
  Vector2d otherGoaliePos;
}; // class MrbCoach
