//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator 
// League of the RoboCup 2000 competition
//
// Copyright (C) 1998, 1999, 2000 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//
// $Id: Config.h,v 1.4 2000/10/19 15:27:42 goetz Exp $
//
//////////////////////////////////////////////////////////////////////


#ifndef CONFIG_H
#define CONFIG_H

#include "coordinates.h"
class Config
{
public:
	// reads a configuration file. returns true if successful.
	static bool readFile (const char *name);

	// returns value for key. might return 0, if key wasn't set in any configuration file
	static const char *getValue (const char *key);
	
	static double getValueAsDouble(const char *key);
	static int getValueAsInt (const char *key);
	static Vector2d getValueAsVector (const char *key);
};

#endif

/* configuration files look like this:

v = 1.4, 1.5       # getValueAsVector("v")
lexiconserverhost	=	lexi
lexiconserverport	=	2811

# things which have been hard coded in clusterConfig.pm

mainDataServer = xnfo2.diefirma.de
numNodes       = 5
node0          = node000
node1          = node001
node2          = node002
node3          = node003
node4          = node004

*/
