//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator 
// League of the RoboCup 2000 competition
//
// Copyright (C) 1998, 1999, 2000 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//-*- c++ -*-/////////////////////////////////////////////////////////
//
//  $Id: datastore.h,v 1.4 2000/10/19 15:27:46 goetz Exp $
// 
//  datastore.h - storing of SensorData in fixed array
// 
//////////////////////////////////////////////////////////////////////


#ifndef _DATASTORE_H_
#define _DATASTORE_H_


#include "sensor.h"
#include <iostream.h>

const int DATA_STORE_SIZE = 20; // size of static array for SensorData


class SensorDataStore {

 public:

  SensorDataStore();
  ~SensorDataStore();
  
  void put(SensorData data);      // add data at end of queue
  void insert(SensorData data);   // insert before all data from same timestep 
  bool getNext(SensorData &data); // return first data in queue
  
 private:

  SensorData store [DATA_STORE_SIZE];

  int readIndex;
  int writeIndex;
   
};


#endif
