//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator 
// League of the RoboCup 2000 competition
//
// Copyright (C) 1998, 1999, 2000 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

// -*- c++ -*- ///////////////////////////////////
//
// $Id: playerlogReader.h,v 1.8 2000/10/19 15:27:57 goetz Exp $
//
// playerlogReader.h
//
//////////////////////////////////////////////////

#ifndef _PLAYERLOGREADER_H_
#define _PLAYERLOGREADER_H_

#include <iostream.h>
#include <stdio.h>

#include "drawables.h"


class PlayerlogReader {

public:

  // when printing the players sent commands: lookback range
  static const int NUM_OLD_COMMANDS = 4;

  // size of static store
  static const int MAX_OUTPUT_LINE = 300000;



  // reads data from player logfile (player.log) into line array
  // maxLine contains highest index of line array afterwards.
  PlayerlogReader(const char* filename);
  ~PlayerlogReader();

  // print relevant lines of player output for <time>
  void printOutput(int time);
  
  // print commands sent just before and for <time>
  void printCommands(int time);

  // draw graphical debugging output for <time>
  void drawOutput(int time, DrawablesList *drawables);

private:

  // the line store
  char *lines [MAX_OUTPUT_LINE];

  // maximum index in lines
  int maxLine;

  
};  

#endif
