//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator 
// League of the RoboCup 2000 competition
//
// Copyright (C) 1998, 1999, 2000 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

// -*- c++ -*- ///////////////////////////////////
//
// $Id: snaplogReader.h,v 1.8 2000/10/19 15:27:58 goetz Exp $
//
// snaplogReader.h
//
//////////////////////////////////////////////////

#ifndef _SNAPLOGREADER_H_
#define _SNAPLOGREADER_H_


#include <iostream.h>
#include <fstream.h>
#include "snapshot.h"

class SnaplogReader {

public:

  static const int MAX_TIME = 8000;

  // reads snapshots from a player's snaps logfile via random file access.
  // maxSnap is set after generating the index of timesteps.
  SnaplogReader(const char* filename);
  ~SnaplogReader();

  // returns recorded snapshot for simstep <time>
  Snapshot* getSnapshot(int time);

  int getMaxTime() { return maxTime; }

private:

  // snap input stream
  ifstream in;

  // temporary local Snapshot store
  Snapshot* snap;

  // array mapping simulation time to the relevant index in snaps stream
  int index [MAX_TIME];
  
  // maximum time recorded in file
  int maxTime;
  
};  

#endif
