/*
 *Header:
 *File: typedefs.h 
 *Author: Noda Itsuki
 *Date: 1995/02/24
 *$Id: types.h,v 1.3 2000/07/25 11:48:55 eri Exp $
 *EndHeader:
 */

/*
 *ModifyHistory
 *
 *EndModifyHistory
 */

typedef double Value ;
typedef int ID ;
typedef int TheNumber ;
typedef char* Name ;
typedef int Logical ;

#define NULLCHAR	'\000'

/*
We're not always picking up a later version of Linux, so we'll
just use an unsigned int
  #ifdef Linux_2_2
#define SOCKLEN_T socklen_t
#else
#define SOCKLEN_T int
#endif
*/
//#define SOCKLEN_T unsigned int
#define SOCKLEN_T size_t

/*
class Angle : public double {} ;
*/
//typedef double Angle ;

#define TRUE 1 
#define FALSE 0 
#define	True 1
#define False 0

#define	DISABLE			0x0000
#define	STAND			0x0001
#define	KICK			0x0002
#define KICK_FAULT		0x0004
#define	GOALIE			0x0008
#define CATCH			0x0010
#define CATCH_FAULT		0x0020
#define BALL_TO_PLAYER	0x0040
#define PLAYER_TO_BALL	0x0080
#define DISCARD			0x0100
// [I.Noda:00/05/13] added for 3D viewer/commentator/small league
#define LOST			0x0200

typedef int	Side ;
#define LEFT	1
#define NEUTRAL	0
#define RIGHT 	-1

#define PLAYMODE_STRINGS {"",\
			"before_kick_off",\
			"time_over",\
			"play_on",\
			"kick_off_l",\
			"kick_off_r",\
			"kick_in_l",\
			"kick_in_r",\
			"free_kick_l",\
			"free_kick_r",\
			"corner_kick_l",\
			"corner_kick_r",\
			"goal_kick_l",\
			"goal_kick_r",\
			"goal_l",\
			"goal_r",\
			"drop_ball",\
			"offside_l",\
			"offside_r",\
			"penalty_kick_l",\
			"penalty_kick_r",\
			"first_half_over",\
			"pause",\
			"human_judge",\
			"foul_charge_l",\
			"foul_charge_r",\
			"foul_push_l",\
			"foul_push_r",\
			"foul_multiple_attack_l",\
			"foul_multiple_attack_r",\
			"foul_ballout_l",\
			"foul_ballout_r",\
		}

#define PLAYMODE_STRINGS_SHORT {"",\
			"bko",\
			"to",\
			"play",\
			"kol",\
			"kor",\
			"kil",\
			"kir",\
			"fkl",\
			"fkr",\
			"ckl",\
			"ckr",\
			"gkl",\
			"gkr",\
			"gl",\
			"gr",\
			"db",\
			"ol",\
			"or",\
			"ps",\
			"hj",\
			"flcl",\
			"flcr",\
			"flpl",\
			"flpur",\
			"flml",\
			"flmr",\
			"flbl",\
			"flbr",\
		}

typedef enum _PlayMode {
	PM_Null,
	PM_BeforeKickOff,
	PM_TimeOver,
	PM_PlayOn,
	PM_KickOff_Left,
	PM_KickOff_Right,
	PM_KickIn_Left,
	PM_KickIn_Right,
	PM_FreeKick_Left,
	PM_FreeKick_Right,
	PM_CornerKick_Left,
	PM_CornerKick_Right,
	PM_GoalKick_Left,
	PM_GoalKick_Right,
	PM_AfterGoal_Left,
	PM_AfterGoal_Right,
	PM_Drop_Ball,
	PM_OffSide_Left,
	PM_OffSide_Right,
	// [I.Noda:00/05/13] added for 3D viewer/commentator/small league
	PM_PK_Left,
	PM_PK_Right,
	PM_FirstHalfOver,
	PM_Pause,
	PM_Human,
	PM_Foul_Charge_Left,
	PM_Foul_Charge_Right,
	PM_Foul_Push_Left,
	PM_Foul_Push_Right,
	PM_Foul_MultipleAttacker_Left,
	PM_Foul_MultipleAttacker_Right,
	PM_Foul_BallOut_Left,
	PM_Foul_BallOut_Right,
	PM_MAX 
} PlayMode ;

typedef enum _MPObjectType {
	MPO_Ball,
	MPO_Player,
} MPObjectType ;

#define Zero 0.0e0

#define	COLOR_NAME_MAX	64

typedef struct {
	short	enable ;
	short	side ;
	short	unum ;
	short	angle ;
	short	x ;
	short	y ;
} pos_t ;

typedef struct {
	char	name[16] ;
	short	score ;
} team_t ;

typedef struct {
	char	pmode ;
	team_t	team[2] ;
	pos_t	pos[MAX_PLAYER * 2 + 1] ;
	short	time ;
} showinfo_t ;

typedef	struct {
	short	board ;
	char	message[2048] ;
} msginfo_t ;

typedef struct {
	short	x ;
	short	y ;
	char	color[COLOR_NAME_MAX] ;
} pointinfo_t ;

typedef struct {
	short	x ;
	short	y ;
	short	r ;
	char	color[COLOR_NAME_MAX] ;
} circleinfo_t ;
	
typedef struct {
	short	x1 ;
	short	y1 ;
	short	x2 ;
	short	y2 ;
	char	color[COLOR_NAME_MAX] ;
} lineinfo_t ;

typedef struct {
	short mode ;
	union {
		pointinfo_t		pinfo ;
		circleinfo_t	cinfo ;
		lineinfo_t		linfo ;
	} object ;
} drawinfo_t ;

typedef struct {
	short	mode ;
	union {
		showinfo_t	show ;
		msginfo_t	msg ;
		drawinfo_t	draw ;
	} body ;
} dispinfo_t ;

typedef struct displist {
	unsigned long	shost ;
	int				sport ;
	struct displist *next ;
} displist_t ;

typedef struct {
	char	optname[32] ;
	void	*vptr ;
	int		vsize ;
} option_t ;

#define	V_INT		1
#define	V_DOUBLE	2
#define	V_BOOL		3
#define	V_STRING	4
#define	V_ONOFF		5
#define V_NONE		6
