//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator 
// League of the RoboCup 2000 competition
//
// Copyright (C) 1998, 1999, 2000 Team Members 
// of the Mainz Rolling Brains RoboCup Team 
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//// -*- c++ -*- ///////////////////////////////////////////////////
//
// $Id: scanpos.h,v 1.4 2000/10/19 15:27:59 goetz Exp $
// $Manager: holgi$
//
// scanpos.h 
//           
// author: <holgi>
//
/////////////////////////////////////////////////////////////////////



#ifndef _SCANPOS_H_
#define _SCANPOS_H_

#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>
#include <fstream.h>

#include "constants.h"

#include "param.h"    // both files belong to the original
#include "types.h"    // soccer-monitor logplayer, that writes the soccer.log,

//////////////
//
// ScanPos class
//
//////////////

class ScanPos {
public:
  ScanPos():
    logfileopen(false)
  {}

  int OpenFile(const char *logfilename); // open the file logfilename
                                         // returns 1 if successful, else 0
                                         // sets bool logfileopen to true if successful
  int CloseFile(); // close logfile if exist, returns 1 if succesful, else 0

  int writePos(bool side); // side = true means: scan left side 
  int doField(); // write fieldcoordinates for plotting with gnuplot
private: 
  ofstream posobject[11]; // file containing players pos
  ifstream logfile;       // logfile to scan
  bool logfileopen;

  int readnextShow(showinfo_t &show); // reads the next showinfo_t in the logfile
                                      // returns 1 if successful, else 0
                                      // show contains the next showinfo_t

  int readMode();   // reads the next mode of the following information
                    // returns -1 in case of failure
                    // else 0 for no info
                    //      1 for showinfo_t
                    //      2 for msginfo_t
                    //   or 3 for drawinfo_t following in logifle
  showinfo_t readShow();  // reads next show-
  msginfo_t readMsg();    //            message-
  drawinfo_t readDraw();  //         or draw-information in the logfile
}; // class ScanPos

#endif
