//-*- c++ -*-/////////////////////////////////////////////////////////// 
//
//   $Id: main.C,v 1.4 2000/08/10 12:00:29 goetz Exp $
//
////////////////////////////////////////////////////////////////////////

#include <stdlib.h>
#include <unistd.h>
#include <iostream.h>
#include <strings.h>
#include "constants.h"
#include "olcoach.h"

int main (int argc, char** argv) {
  char   *team_name= "MRB";
  char   *host= new char [strlen(DEFAULT_HOST)+1];
  strcpy (host, DEFAULT_HOST);
  int    port = OLCOACH_PORT;
  double mapWinMag = 0.0;
  bool   logging = false;
  char   *configfile= "agent.conf";

  char   c;
  while((c = getopt( argc, argv, "h:lm:p:t:f:" ) ) != EOF ) {
    switch(c) {
    case 'h':
      delete (host);
      host = optarg;
      break;
    case 'l':
      logging = true;
      break;
    case 'm':
      mapWinMag = atof( optarg );
      break;
    case 'p':
      port = atoi(optarg);
      break;
    case 't':
      team_name = optarg;
      break;
    case 'f':
      configfile= optarg;
      break;
    case '?':	// Fehler beim parsen bzw. help-Option
    cerr << "Usage: " << argv[0] << "[-h HOSTNAME]"
      " [-l] [-m MAGNIFY] [-p PORT] [-t TEAMNAME]" 
      "[-f FILENAME]" << endl
	 << "  -h HOSTNAME  connects to HOSTNAME" << endl
	 << "  -l           enable server message logging (to \"snaps*.log\")" << endl
	 << "  -m MAGNIFY   enable mapwindow with size magnification factor MAGNIFY" << endl
	 << "  -p PORT      port number" << endl
	 << "  -t TEAMNAME  sets the coaches team name" << endl
	 << "  -f FILENAME  alternative configuration file for tactics (default agent.conf)" << endl;
    exit(1);
    }
  }

  OlCoach *a = new OlCoach(team_name, host, port, 
			   mapWinMag, logging);
  a->coach();

  delete (a);
}


